#include <stdio.h>
#include "../PVLIB/pv.h"
#define TMPFILE "/tmp/pvfuncs"
complex zero = { 0., 0. };
complex one = { 1., 0. };
float IPI;
float TWOPI;
extern char *arg_option ;
main(argc, argv)
    int argc; char *argv[];
{
int R=44100, N=1024, D = 512 ;
  char ch ;
  char soundin[64] = "soundin.";
  char fname[64];
  char sfnum = 1 ;
  int stblock = 2, endblock = 20, blocks ;
  float duration, outdur;
  int frames = 0;
  int i,j;
  int flen;
  float **wherehouse;
  FILE *fopen(), *fp, *fpout;
  int bad_read_flag;
  int new_frame_len;
  float norml = 0. ;
    if (isatty(0))
	usage(1);
    while( (ch= crack( argc, argv, "R|N|D|h|f|n|b|B|", 0  )) != NULL ) {
	switch(ch) {
	    case 'R':	R = atoi(arg_option);
			break;
	    case 'N':	N = atoi(arg_option);
			break;
	    case 'D':	D = atoi(arg_option);
			break;
	    case 'f':	frames = atoi(arg_option);
			break;
	    case 'n':	norml = atof(arg_option);
			break;
	    case 'b':	stblock = atoi(arg_option);
			break;
	    case 'B':	endblock = atoi(arg_option);
			break;

	    case 'h':	usage(1);
	}
    }

  if( ( wherehouse = (float **) calloc(frames, sizeof(float *) ) ) == NULL) memerr();
    for ( i=0; i < frames; i++ ) {
      if( (*(wherehouse+i) = (float *) calloc(N+2, sizeof(float)) ) == NULL) memerr();
    }

 frames = ReadPvAnal( wherehouse, N) ;

fprintf(stderr,"EXTRACT: ANALYSIS SCAN COMPLETED\n");
blocks = endblock - stblock ;
stblock *= 2 ; blocks *= 2;
/* KLUDGE TO CREATE SOUNDFILE NAMES     */
fp = openfile( TMPFILE, "w" );
for(i=0;i<blocks;i++)
   fprintf(fp,"%s%d\n",soundin, i+1);
fclose( fp ); 
fp = openfile( TMPFILE, "r" );
/* NORMALIZE */
if( norml )
  PVnormalize( wherehouse, stblock, blocks, frames, norml ) ;

for(i = stblock; i < stblock+blocks ; i++ ){
   fscanf(fp,"%s",fname );
   fpout = openfile( fname, "w" );
   fprintf(stderr,"writing %s\n",fname);
   for( j = 0; j < frames ; j++ ){
      fwrite( &wherehouse[j][i], sizeof(float), 1, fpout );
   }
   fclose( fpout );
}

    fprintf(stderr,"EXTRACT: COMPLETED, READ %d FRAMES\n",frames);
    exit(0);
}

memerr()
{
fprintf(stderr,"Richard Wagner Alert: No Memory Left\n");
exit(-1);
}
ReadPvAnal( arr, N ) float **arr ; int N ;
{
int i, j, new_frame_len;
int bad_read_flag = 0;
for(i = 0; ; i++ ){
  for( j = 0; j < N+2; j++ )
     if ( fread(&arr[i][j],sizeof(float),1,stdin) == NULL ){
        bad_read_flag = 1;
	break;
}
if( bad_read_flag){
   new_frame_len = i;
   break;
   }
}
	     fprintf(stderr, "read %d frames \n", new_frame_len );
	     return( new_frame_len );
}
PVnormalize( arr, stblock, blocks, frames, norml ) 
float **arr, norml ; int stblock, blocks, frames;
{
float maxamp = 0.;
float rescale;
int i, j;
for(i = stblock; i < stblock+blocks ; i+= 2 ){
   for( j = 0; j < frames ; j++ ){
      if( arr[j][i] > maxamp ){
         maxamp = arr[j][i] ;
      }
   }
}
if( maxamp != 0. )
  rescale = norml / maxamp ;
else{
fprintf(stderr,"ALL ZERO ANALYSIS BLOCK, EXITING.\n");
exit(-1);
}
fprintf( stderr, "maxamp = %f , rescale = %f\n",maxamp, rescale);
for(i = stblock; i < stblock+blocks ; i+= 2 ){
   for( j = 0; j < frames ; j++ ){
         arr[j][i] *= rescale;
   }
}
}

usage(meow)
{
    fprintf(stderr, "%s",
	"extract:  select pvoc data in Csound function format\n"
	"extract   [flags] < floatsams > floatsams\n"
	"	N:	fft length [1024]\n"
	"	R:	sampling rate [44100]\n"
	"	D:	decimation factor in samples [512]\n"
	"	b:	start block\n"
	"	B:	end block\n"
	"	f:	number of frames to read in\n"
	"	n:	optional normalization target\n"

	);
    exit(meow);
}
