#include <stdio.h>
#include "../PVLIB/pv.h"

complex zero = { 0., 0. };
complex one = { 1., 0. };
float IPI;
float TWOPI;
float synt = 0.;
extern char *arg_option;
main(argc, argv)
    int argc; char *argv[];
{
  int R=44100, N=1024, N2, Nw = 4096, Nw2, D = 512, I = 512, in, on, 
  eof = 0, obank = 0, aflag = 0, sflag = 0;
  float P = 0., len, tincr, tpos, *Hwin, *Wanal, *Wsyn, *input, *winput,
  *buffer, *channel, *output; 
  char	ch, *dbuf;
  char leakfuncname[128] = "leakfunc", lookfuncname[128] = "func";
  char pvname1[128] = "pvanal1.i";
  char pvname2[128] = "pvanal2.i";
  float duration=0., outdur=0.;
  int pvcount = 0;
  int N_Frames1 = 0, N_Frames2 = 0;
  int N_OutFrames;
  int i,j, k,l;
  int flen, leaklen;
  float **wherehouse1, **wherehouse2;
  float *lookupfunc, *tfunc, *leakfunc, *lookup1, *lookup2;
  FILE *openfile(), *fp1, *fp2, *fp3, *fp4;
  int bad_read_flag;
  int new_frame_len;
  int ioffset;
  int pos1, pos2, leakpos;
  float time_offset = 0.0;
  float funcbot=0., functop=1.;
  float indur1, indur2 ;
  int *sieve;
  int exchange ;
  int rescaleflag = 0;
  
   /* if (isatty(0))
	usage(1); */
    while( (ch= crack( argc, argv, "R|N|M|I|D|o|O|s|S|f|F|l|L|p|P|", 0  )) != NULL ) {
	switch(ch) {
	    case 'R':	R = atoi(arg_option);
			break;
	    case 'N':	N = atoi(arg_option);
			break;
	    case 'M':	Nw = atoi(arg_option);
			break;
	    case 'I':	I = atoi(arg_option);
			break;
	    case 'D':	D = atoi(arg_option);
			break;

	    case 'l':   indur1 = atof(arg_option);
			break;
	    case 'L':   indur2 = atof(arg_option);
			break;
	    case 'o':   outdur = atof(arg_option);
	    		break;
	    case 'O':   time_offset = atof(arg_option);
	    		break;
	    case 's':   funcbot = atof(arg_option);
	    		rescaleflag = 1 ;
	    		break;
	    case 'S':   functop = atof(arg_option);
	    		rescaleflag = 1 ;
	    		break;
	    case 'f':   strcpy(lookfuncname, arg_option);
			break;
	    case 'F': 	strcpy(leakfuncname, arg_option);
	    		break;
	    case 'p': 	strcpy(pvname1, arg_option);
	    		break;
	    case 'P': 	strcpy(pvname2, arg_option);
	    		break;

	    case 'h':	usage(1);
	}
    } 
    if( indur1 <= 0.0  || indur2 <= 0.0) {
      fprintf(stderr,"must specify input durations\n");
      usage(-1);
      exit(-1);
    }
    if( outdur <= 0.0  ) {
      fprintf(stderr,"must specify output duration\n");
      exit(-1);
    }
    N_Frames1 = (int) ((((float)R+(float)Nw)/(float)I)*indur1);
    N_Frames2 = (int) ((((float)R+(float)Nw)/(float)I)*indur2);
    fp1 = openfile( lookfuncname, "r" );
    flen = readin( fp1, &lookupfunc );
      /* OPTIONAL FUNCTION RESCALE   */
    if( rescaleflag )
       norman( lookupfunc, funcbot, functop, flen );
    for(i = 0; i < flen; i++ )
       if( (lookupfunc[i] < 0.0) || (lookupfunc[i] > 1.0) ){
          fprintf(stderr,"Lookup function exceeds enforced boundaries 0.0-1.0\n");
	  exit(-1);
        } 
      /* OPTIONAL FUNCTION TIME OFFSET   */
      if( time_offset != 0.0 ){
         tfunc = (float *) space( flen, sizeof(float) );	
         ioffset = (time_offset/outdur)*(float)flen ;
	 fprintf(stderr,"FUNCTION OFFSET = %d\n", ioffset);
	 for( i = 0; i < flen ; i++)
	    tfunc[i] = lookupfunc[(i+ioffset)%flen] ;
	 for( i = 0; i < flen ; i++)
	    lookupfunc[i] = tfunc[i] ;
      } 
     fp2 = openfile( leakfuncname, "r" ); 
     leaklen = readin( fp2, &leakfunc );
     for(i = 0; i < leaklen; i++ )
       if( (leakfunc[i] < 0.0) || (leakfunc[i] > 1.0) ){
          fprintf(stderr,"leak function exceeds enforced boundaries 0.0-1.0\n");
	  exit(-1);
        }
    N_OutFrames =(int)((outdur)*((float)R/(float)I));
    if (Nw == 0)
	Nw = N;
    if (I == 0)
	I = D;

    IPI = 4.*atan(1.);
    TWOPI = 8.*atan(1.);
    obank = P != 0.;
    N2 = N>>1;
    Nw2 = Nw>>1;
    Wanal = (float *) space( Nw, sizeof(float) );
    Wsyn = (float *) space( Nw, sizeof(float) );
    input = (float *) space( Nw, sizeof(float) );
    Hwin = (float *) space( Nw, sizeof(float) );
    winput = (float *) space( Nw, sizeof(float) );
    buffer = (float *) space( N, sizeof(float) );	   
    channel = (float *) space( N+2, sizeof(float) );    
    output = (float *) space( Nw, sizeof(float) );
    lookup1 = (float *) space( flen, sizeof(float) );	
    lookup2 = (float *) space( flen, sizeof(float) );	
    sieve = (int *) space( N+2, sizeof(int) );	

    if( ( wherehouse1 = (float **) calloc(N_Frames1, sizeof(float *) ) ) == NULL) 
       memerr();
    for ( i=0; i < N_Frames1; i++ ) 
       if( (*(wherehouse1+i) = (float *) calloc(N+2, sizeof(float)) ) == NULL) 
          memerr();
    if( ( wherehouse2 = (float **) calloc(N_Frames2, sizeof(float *) ) ) == NULL) 
       memerr();
    for ( i=0; i < N_Frames2; i++ ) 
       if( (*(wherehouse2+i) = (float *) calloc(N+2, sizeof(float)) ) == NULL) 
          memerr();

    makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank );

    in = -Nw;
    on = in;

bad_read_flag = 0;
   fp3 = openfile( pvname1, "r" ); 
   for( i = 0 ; i < N_Frames1; i++ ){
      for( j = 0; j < N+2; j++ )
	 if ( fread(&wherehouse1[i][j],sizeof(float),1,fp3) == NULL ){
	    bad_read_flag = 1;
	    break;
         }
    }
    if( bad_read_flag) N_Frames1 = i;
   fprintf(stderr,"LEAKY: ANALYSIS SCAN 1 COMPLETED, READ %d FRAMES\n", N_Frames1);
   fp4 = openfile( pvname2, "r" ); 
   for( i = 0 ; i < N_Frames2; i++ ){
      for( j = 0; j < N+2; j++ )
	 if ( fread(&wherehouse2[i][j],sizeof(float),1,fp4) == NULL ){
	    bad_read_flag = 1;
	    break;
         }
    }
    if( bad_read_flag) N_Frames2 = i;
    fprintf(stderr,"LEAKY: ANALYSIS SCAN 2 COMPLETED, READ %d FRAMES\n", N_Frames2);
 /* SCALE FUNCTION TO NUMBER OF ANALYSIS FRAMES    */
    cpfunc( lookup1, lookupfunc, flen );
    cpfunc( lookup2, lookupfunc, flen );
    rescale( lookup1, flen, N_Frames1 );
    rescale( lookup2, flen, N_Frames2 );
    rescale( leakfunc, leaklen, N2 );
    
    RandSet( sieve, N2 ) ;
    /* SYNTHESIS LOOP */
    for(j = 0; j < N_OutFrames ; j++) {
	on += I;
/* CURRENT FUNCTION DIRECTLY RETURNS FRAME (int) SUBSCRIPT   */

	pos1 = getloc(j, flen, lookup1, N_OutFrames, N_Frames1);
	pos2 = getloc(j, flen, lookup2, N_OutFrames, N_Frames2);
        leakpos = ((float)j/(float)N_OutFrames)*(float)(leaklen-1);

        exchange = (int)leakfunc[leakpos];
/* fprintf(stderr,"fpos1 %d fpos2 %d\n",pos1,pos2);
	//fprintf(stderr,"exchange = %d\n",exchange);   */
	for( k = 0, l = 0; k < N+2; k+=2, l++ ){
	/*   fprintf(stderr,"exchange = %d, sieve = %d\n",exchange, sieve[l]);   */
	   if( sieve[l] < exchange ){
	      channel[k] = wherehouse1[pos1][k];
	      channel[k+1] = wherehouse1[pos1][k+1];
	   }
	   else {
	      channel[k] = wherehouse2[pos2][k];
	      channel[k+1] = wherehouse2[pos2][k+1];
	   }
	}
/* GENERATE WAVEFORM    */
	unconvert( channel, buffer, N2, I, R );
        rfft( buffer, N2, INVERSE );
	overlapadd( buffer, N, Wsyn, output, Nw, on );
	shiftout( output, Nw, I, on );
    } 
/* TERMINATE  */
    fprintf(stderr,"LEAKY: SYNTHESIS COMPLETED\n");
    exit(0);
}

rescale( arr, len, max ) float arr[]; int len, max;
{
  int i;
  for(i = 0; i < len ; i++){
    arr[i] *= (float) max;
  }
}
getloc( pos, flen, arr, max, maxf)
int pos, flen, max, maxf; float arr[];
{
int frame;
int fpos;
double rint();
  max -= 1;
  flen -= 1;
  fpos = (int) rint((float)pos * ((float)flen / (float) max ));
  if( fpos > flen ) 
     fprintf(stderr,"getloc: array out of bounds: pos = %d, len = %d, fpos = %d\n",
      pos,flen,fpos);
  frame = (int) rint(arr[fpos]);
  /* HERE IS THE FIX FOR OUT OF BOUNDS ON ANALYSIS ARRAY   */
  if( frame >= maxf ) 
    frame = maxf-1;
  if( frame < 0 )
    frame = 0;
  return(frame);
}
usage(meow)
{
    fprintf(stderr, "%s",
	"leaky:  pvoc data surfing pairs\n"
	"leaky   [flags]  > floatsams\n"
	"	N:	fft length [1024]\n"
	"	R:	sampling rate [44100]\n"
	"	M:	window size in samples [4096]\n"
	"	I:	interpolation factor in samples [512]\n"
	"	D:	decimation factor in samples [512]\n"
	"	l:	duration of input1 [undefined]\n"
	"	L:	duration of input2 [undefined]\n"
	"	o:	duration of output [undefined]\n"
	"	O:	time offset for function [0.]\n"
	"	f:	name of lookup function [func]\n"
	"	F:	name of leaking function [leakfunc]\n"
	"	p:	name of analysis file 1 [pvanal1.i]\n"
	"	P:	name of analysis file 2 [pvanal2.i]\n"
	"	s:	floor for rescaling control function\n"
	"	S:	ceiling for rescaling control function\n"
	);
    exit(meow);
}

cpfunc( arr1, arr2, len ) float *arr1, *arr2; int len;
{
   int i;
   for(i=0;i<len;i++)
      arr1[i] = arr2[i];
}
memerr()
{
fprintf(stderr,"Richard Wagner Alert: No Memory Left\n");
exit(-1);
}
ShowExtrema( arr, len, name ) float *arr; int len; char *name;
{
   float min = 100000000.;
   float max = 0.;
   int i;
   
   for(i = 0; i < len; i++ ){
      if( min > arr[i] ) min = arr[i];
      if( max < arr[i] ) max = arr[i];
   }
   fprintf(stderr,"%s EXTREMES: %.0f %.0f\n",name,min,max);
}

RandSet( arr, N ) int *arr, N ;
{
int i, j;
int NSwitch = 100000 ;
int temp ;
int pos1, pos2;
srandom( time( 0 ) );
for( i = 0; i < N; i++ )
   arr[i] = i;
for( i = 0; i < NSwitch; i++ ){
   pos1 = random()%N;
   pos2 = random()%N;
   temp = arr[pos2];
   arr[pos2] = arr[pos1];
   arr[pos1] = temp ;
   }
}

