#include <stdio.h>
#include "../PVLIB/pv.h"
/* 3-95 bug fix: needed declaration of atof()   */
complex zero = { 0., 0. } ;
complex one = { 1., 0. } ;
float IPI ;
float TWOPI ;
float synt ;
extern char *arg_option;

main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j;
float cfac = 2.00;
float basefreq;
int cnt;
float nyquist;
double atof();
  int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
  int   eof = 0, obank = 0,  sflag = 0;
 float P = 1.0, len, tincr, tpos;
 float harmadd=0.;
  FILE *fopen(), *fp;
char ch;
float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel, *ratios, *output ;
 float maxampval;
 float *shifties ;
 int rand_shift_absolute=0;
 int rand_shift_by_percentage=0;
 float threshfac = .001;
 float maxigain;
 float lobound=0.,hibound=0.;
float getthresh();
float randf();
    if (isatty(0))
	usage(1);
    while( (ch= crack( argc, argv, "R|N|M|P|D|t|I|F|f|l|o|s|a|x|X|b|B|h", 0  )) != NULL ) {
	switch(ch) {
	    case 'R':	R = atoi(arg_option);
			break;
	    case 'N':	N = atoi(arg_option);
			break;
	    case 'M':	Nw = atoi(arg_option);
			break;
	    case 'D':	D = atoi(arg_option);
			break;
	    case 'I':	I = atoi(arg_option);
			break;
	    case 'P':	P = atof(arg_option);
			break;
	    case 'f':	cfac = atof(arg_option);
			break;
	    case 't':	threshfac = atof(arg_option);
			break;
	    case 'a':	harmadd = atof(arg_option);
			break;
	    case 'x':	rand_shift_absolute = 1;
			break;
	    case 'X':	rand_shift_by_percentage = 1;
			break;
	    case 'b':	lobound = atof(arg_option);
			break;
	    case 'B':	hibound = atof(arg_option);
			break;
	    case 's':	sflag = 1;
			break;
	    case 'h':	usage(1);
	}
    }
if((rand_shift_absolute || rand_shift_by_percentage)&& hibound == 0.){
	fprintf(stderr,"you must set at least the high boundary for random action\n");
}
if( harmadd == 0. && !rand_shift_absolute && !rand_shift_by_percentage){
	fprintf(stderr,"You must specify the frequency shift\n");
	usage(1);
	}
if(rand_shift_absolute || rand_shift_by_percentage){
	srandom(time(0));
	shifties = (float *) calloc(N, sizeof(float) );
	for(i = 0 ; i < N; i++ ){
		shifties[i] = randf(lobound,hibound);
	/*	fprintf(stderr,"%f\n",shifties[i]);     */
		}
}
    IPI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    nyquist = R/2.0;
    obank = P != 0. ;
    if( P == 0.0 ) {P = 1.0;
    }
    N2 = N>>1 ;
    Nw2 = Nw>>1 ;

    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, N+2 ) ;	/* analysis channels */
    fvec( output, Nw ) ;	/* output buffer */
    makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;
	
    while ( !eof ) {
	in += D ;
	on += I ;
		if( sflag ){
			if( fread(channel, sizeof(float) , N+2, stdin) == NULL )
				eof = 1;
		}
		else {
	 	  eof = shiftin( input, Nw, D ) ;
	  	  fold( input, Wanal, Nw, buffer, N, in ) ;
	  	  rfft( buffer, N2, FORWARD ) ;
	  	  convert( buffer, channel, N2, D, R ) ;
		}
		if(rand_shift_absolute){
		 	for( i = 1, j = 0; i < N; i+= 2, j++ )
		 		channel[i] += shifties[j];
		} else if(rand_shift_by_percentage){
		 	for( i = 1, j = 0; i < N; i+= 2, j++ )
		 		channel[i] += (channel[i] * shifties[j]);
		} else {
 		 	for( i = 1; i < N; i+= 2 )
		 		channel[i] += harmadd;
			}
		if( P > 1. )
       	 for(i=1;i<N;i+=2)
             if(channel[i] * P >= nyquist) channel[i-1] = 0.0; 
        synt = getthresh( channel, N, threshfac );
	    noscbank(channel, N2, R, Nw, I, P, output);
	    shiftout( output, Nw, I, on+Nw-I );

    }
    fprintf(stderr,"PVSHIFT: RESYNTHESIS COMPLETED\n");
    exit( 0 ) ;
}
usage(woof)
{
    fprintf(stderr, "%s",
	"pvshift:  pitch shift\n"
	"pvshift   [flags] < floatsams > floatsams\n"
	"	N:	fft length [1024]\n"
	"	R:	sampling rate [44100]\n"
	"	M:	window size in samples [2048]\n"
	"	D:	decimation factor in samples [256]\n"
	"	I:	interpolation factor in samples [256]\n"
    "	P:	pitch factor [1.0]\n"
	"	a:	frequency shift factor\n"
	"	x:	set random shift with absolute boundaries\n"
	"	X:	set random shift with relative boundaries\n"
	"	b:	lower boundary\n"
	"	B:	upper boundary\n"
	"	t:	oscillator resynthesis threshold [.001]\n"
	"	s:	synthesize analysis input\n"
	);
    exit(woof);
}

