#include <stdio.h>
#include "../PVLIB/pv.h"

complex zero = { 0., 0. } ;
complex one = { 1., 0. } ;
float IPI ;
float TWOPI ;
float synt ;
extern char *arg_option;
main( argc, argv )
    int argc ; char *argv[] ;
{
/* double atof();   */
int i,j;
float cfac = 1.00;
float freq_thresh = 3000.0;
int cnt;
float nyquist;
  int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
  int   eof = 0, obank = 0, aflag = 0, sflag = 0, Np;
 float P = 1.0, len, tincr, tpos;
 float tadv, realtime, tlength;
 float duration;
 int flen, tlen1, tlen2, tlen3, ipos;
 char fname[128];
 char gap_fname[128];
 char tab1name[128];
 char tab2name[128];
 float *warpfunc;
 float *tab1;
 float *tab2;
 float imult;
 int hoop;
 int gap_flag = 0;
 FILE *fopen(), *fp, *fp1, *fp2, *fp3;
 char ch;
 float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel,*output ;
 float *gap_func;
 float tfac = .001;
 strcpy( fname, "func" ); /* DEFAULT NAME OF FUNCTION   */
 strcpy( tab1name, "func1" );
 strcpy( tab2name, "func2" );
    if (isatty(0))
	usage(1);
while( (ch= crack( argc, argv, "T|R|N|M|P|D|t|I|F|f|l|v|s|h|g|", 0  )) != NULL ) {
	switch(ch) {
	    case 'R':	R = atoi(arg_option);
			break;
	    case 'N':	N = atoi(arg_option);
			break;
	    case 'M':	Nw = atoi(arg_option);
			break;
	    case 'D':	D = atoi(arg_option);
			break;
	    case 'I':	I = atoi(arg_option);
			break;
	    case 'P':	P = atof(arg_option);
			break;
	    case 'l':   duration = atof(arg_option);
			break;
	    case 'v':   strcpy(fname, arg_option);
			break;
	    case 'f':   strcpy(tab1name, arg_option);
			break;
	    case 'F':   strcpy(tab2name, arg_option);
			break;
	    case 't':	tfac = atof(arg_option);
			break;
            case 'T':   freq_thresh = atof(arg_option);
                        break;
            case 'g':   strcpy(gap_fname, arg_option);
	    		gap_flag = 1;
                        break;
	    case 's':	sflag = 1;
	                D = 0;
			break;
	    case 'h':	usage(1);
	}
    }
if( duration <= 0.0 ){
   fprintf(stderr,"You must specify duration\n");
   exit(-1);
}
/* DEAL WITH FUNCTIONS   */
    if ( (fp = fopen( fname, "r" )) == NULL ) {
	fprintf(stderr,"warp function %s not found\n",fname);
	exit(-1);
    }
    if ( (fp1 = fopen( tab1name, "r" )) == NULL ) {
	fprintf(stderr,"wave table %s not found\n",tab1name);
	exit(-1);
    }
    if ( (fp2 = fopen( tab2name, "r" )) == NULL ) {
	fprintf(stderr,"wave table %s not found\n",tab2name);
	exit(-1);
    }
    flen = readin( fp, &warpfunc);
    tlen1 = readin( fp1, &tab1 );
    tlen2 = readin( fp2, &tab2 );
    if( tlen1 != tlen2 ){
       fprintf(stderr,"wavetables must be of the same length\n");
       fprintf(stderr,"wave1 is %d, wave2 is %d\n", tlen1, tlen2);
       exit(-1);
    }
    realtime = 0.0;
    tadv = (float)I/(float)R ;
    Np = 0;
    IPI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    if( P == 0.0 ) {P = 1.0;
    }
    N2 = N>>1 ;
    Nw2 = Nw>>1 ;

    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, N+2 ) ;	/* analysis channels */
    fvec( output, Nw ) ;	/* output buffer */
    if( gap_flag ){
       if ( (fp3 = fopen( gap_fname, "r" )) == NULL ) {
	  fprintf(stderr,"resynth bin function %s not found\n", gap_fname);
	  exit(-1);
       }
       tlen3 = readin( fp3, &gap_func );
       if( tlen3 != N/2 ){
          fprintf(stderr,"resynth function must be of length %d\n",N/2);
       }
    }

    makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;
/*
 * main loop--perform phase vocoder analysis-resynthesis
 */
 /*
fprintf(stderr,"I %d D %d R %d M %d\n",I,D,R,Nw);
fprintf(stderr,"tfac %f\n",threshfac); fflush(stderr);
fprintf(stderr,"cfac %f\n",cfac); fflush(stderr);
fprintf(stderr,"P %f\n",P); fflush(stderr);
*/
    while ( !eof && realtime < duration) {
	in += D ;
	on += I ;
	/* READ ANALYSIS DATA   */
	if ( D == 0 ) {
	  for ( hoop=0; hoop < N+2; hoop++ ) {
	      if ( fread(channel+hoop,sizeof(float),1,stdin) <= 0 )
	      eof = 1;
	  }  
	} 
	/* OR PERFORM ANALYSIS   */
	else {
	   eof = shiftin( input, Nw, D ) ;
	   fold( input, Wanal, Nw, buffer, N, in ) ;
	   rfft( buffer, N2, FORWARD ) ;
	   convert( buffer, channel, N2, D, R ) ;
	}
/*  ZERO OUT HIGH FREQUENCY BINS   */
	if( gap_flag ){
           for( i = 0, j = 0; i < N; i += 2, j++ ){
	      if( gap_func[j] < .00001 ){
	         channel[i] = 0.0;
	      }
	   }
	}
	if( freq_thresh > .0001 ){
	   for( i = 0; i < N; i+=2 ){
  	      if( channel[i+1] > freq_thresh ){
	         channel[i] = 0.0;
	      }
	   }
	}
        ipos = (int)((realtime/duration)*(float)(flen -1));
	if( ipos >= flen) {
	  fprintf(stderr,"RED CLAM: index out of bounds\n");
	  ipos = flen - 1;
	}
	imult =  warpfunc[ ipos ];
	realtime += tadv;
	/* RESYNTHESIS - OSC BANK ONLY   */
        red_oscbank( channel, N2, R, Nw, I, P, output, 
                  tlen1, tab1, tab2, imult, tfac );
	shiftout( output, Nw, I, on+Nw-I );
    }
    fprintf(stderr,"RED CLAM: RESYNTHESIS COMPLETED\n");
    exit( 0 ) ;
}
usage(mood)
{
    fprintf(stderr, "%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s",
	"red-clam:  time varying distortion processor\n",
	"red-clam   [flags] < floatsams > floatsams\n",
	"	N:	fft length [1024]\n",
	"	R:	sampling rate [44100]\n",
	"	M:	window size in samples [2048]\n",
	"	D:	decimation factor in samples [256]\n",
	"	I:	interpolation factor in samples [256]\n",
        "	P:	pitch factor [osc bank only][1.0]\n",
       	"	v:	interpolation function [func]\n",
	"	f:	resynthesis function1 [indexed at 0.0] [func1]\n",
	"	F:	resynthesis function2 [indexed at 1.0] [func2]\n",
	"	t:	resynthesis threshold factor[.001]\n",
	"	T:	highest frequncy to resynthesize [3000.0][0. means no action]\n",
	"	l:	duration of input [undefined]\n",
	"	g:	optional bin sieve function [1=on,0=off] of size N/2\n",
	"	s:	synthesize analysis input\n");
    exit(mood);
}

